#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=CFG\IMG\Rubik.ico
#AutoIt3Wrapper_Outfile_x64=Rubik.exe
#AutoIt3Wrapper_Res_Description=Rubik est un script permettant l'accès rapide à différents outils, liens web et serveurs
#AutoIt3Wrapper_Res_Fileversion=7.0.0.0
#AutoIt3Wrapper_Res_CompanyName=Prénom Nom
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
; Adapation du script original : https://www.autoitscript.fr/forum/viewtopic.php?t=6347
#include <Array.au3>
#include <Constants.au3>
#include <Date.au3>
#include <FileConstants.au3>
#include <GUIConstantsEx.au3>
#include <GuiListView.au3>
#include <Misc.au3>
#include <MsgBoxConstants.au3>
#include <TrayConstants.au3>
#include <WindowsConstants.au3>

Opt("TrayMenuMode", 3) 																			; Empêche la mise en pause du script
If _Singleton(@ScriptName, 1) = 0 Then															; Test la présence d'un seul script selon le @ScriptName
;~ 	TrayTip ("Information :", @ScriptName & " est déjà lancé et en cours de fonctionnement !" & @LF & "Cette instance va être fermée.", 5000, 1)
	Sleep (5000)
	Exit
EndIf
;*********************************************************************************************************************************************
$sResult = StringTrimLeft (@ComputerName, 7)													; Récupére le nom du PMF
$ELSM = StringLeft ($sResult, 3)																; Récupére le numéro d'ELSM en fonction du nom de PMF
Global $LOG = @ScriptDir & "\Rubik.log"															; Fichier LOG du Rubik
Global $Fl = ChrW(9658)																			; Affiche une Flèche vers la droite
Global $Fb = ChrW(9661) & " " & ChrW(9661) & " " & ChrW(9661) & " " & ChrW(9661)				; Quadruple Flèche vers le bas
Global $Fd = ChrW(9655) & " " & ChrW(9655) & " " & ChrW(9655) & " " & ChrW(9655)				; Quadruple Flèche vers la droite
FileDelete ($LOG)
;************************************************************************
;* Création d'un fichier LOG dans C:\PMF\RAPPINST\Rubik.log 			*
;************************************************************************
	FileWriteLine ($LOG, "*****************************************************************************************************")
	FileWriteLine ($LOG, "* LOG du Rubik, informations concernant l'ouverture et le démarrage du script : ")
	FileWriteLine ($LOG, "*****************************************************************************************************")
	FileWriteLine ($LOG, @TAB & " Fichier créé le " & _NowDate() & " à " & _NowTime(5))
	FileWriteLine ($LOG, @TAB & " Nom du PMF : " & @ComputerName)
	FileWriteLine ($LOG, @TAB & " Session : " & @UserName)
	FileWriteLine ($LOG, @TAB & " Nom du script : " & @ScriptName)
	FileWriteLine ($LOG, "*****************************************************************************************************")

;*********************************************************************************************************************************************
$Install_Log = @ScriptDir & "\CFG\First_Installation.log"
If Not FileExists ($Install_Log) Then
	FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Première ouverture du Rubik")
	$Question = MsgBox (36, "Premier lancement du Rubik :", "Souhaitez-vous récupérer la configuration de base du Rubik ?" & @LF & @LF & _
							"Oui : " & @LF & "Vous récupérerez la version complète des menus du Rubik (COMMUN tout COMMUN + Votre Site)" & @LF & @LF & _
							"Non : " & @LF & "Vous créez vous même votre menu SELECTION en fonction de vos activités (peut-être fait ultérieurement)")
	If $Question = $IDYES Then
		FileWriteLine ($Install_Log, "Au premier lancement, l'utilisateur a choisi une configuration par défaut")
		FileWriteLine ($Install_Log, "Ce dernier a donc récupéré le fichier de configuration standard régional et local :")
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " L'utilisateur a préféré recupérer la configuration globale")
	EndIf
	If $Question = $IDNO Then
		FileWriteLine ($Install_Log, "Au premier lancement, l'utilisateur a choisi une configuration par sélection")
		FileWriteLine ($Install_Log, "Ce dernier a donc créé sa propre configuration")
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " L'utilisateur a préféré sélectionner ses propres rubriques")
		Run (@ScriptDir & "\CFG\ConfigMenus.exe")
		ProcessClose ("Rubik.exe")
	EndIf
EndIf

$SCRIPT = "Rubik"																				; Nom de l'Application
$CONFIG_Local_BAS			= "CFG\Menu_BAS.ini"													; Fichier de configuration du Menu BAS
$CONFIG_Local_COMMUN			= "CFG\Menu_COMMUN.ini"													; Fichier de configuration du Menu COMMUN
$CONFIG_Local_ELSM			= "CFG\Menu_ELSM.ini"													; Fichier de configuration du Menu ELSM
$CONFIG_Local_PERSONNELLE	= "CFG\Menu_PERSO.ini"													; Fichier de configuration du Menu PERSO
$CONFIG_Local_SELECTION		= "CFG\Menu_SELECTION.ini"												; Fichier de configuration du Menu SELECTION, ATTENTION, désactive Menu COMMUN et ELSM
$CONFIG_NAV   = @ScriptDir & "\CFG\Rubik.ini"													; Fichier de paramétrage du Rubik (navigateur, couleur, ...)
$URL_ini	  = @ScriptDir & "\CFG\Exclusions.ini"												; Fichier des exclusions, force l'ouverture de lien dans IE11
$Maj_IP		  = 0
If Not FileExists ($CONFIG_NAV) Then
	$Select_NAV = FileOpenDialog ("Veuillez sélectionner le chemin de votre navigateur (IE, FIREFOX, BRAVE)", @ProgramFilesDir, "EXE (*.exe)", 1)
	If @error <> 0 Then
		MsgBox (16, "ERREUR", "Vous n'avez sélectionnez aucun fichier")
		Exit
	Else
		IniWrite ($CONFIG_NAV, "NAVIGATEUR", "Chemin", $Select_NAV)
		FileWriteLine ($CONFIG_NAV, "// Définit le chemin d'accès au navigateur à utiliser pour l'ouverture des liens du Rubik")
		IniWrite ($CONFIG_NAV, "COULEUR", "Rubik", "0xCCAA2B")
		FileWriteLine ($CONFIG_NAV, "// Change la couleur de menu du Rubik")
	EndIf
EndIf

If FileExists ("C:\Program Files (x86)\Mozilla Firefox\firefox.exe") Then
	$vFirefox = "C:\Program Files (x86)\Mozilla Firefox\firefox.exe"
	$vfBits = "32 Bits"
	IniWrite ($CONFIG_NAV, "NAVIGATEUR", "Chemin", $vFirefox)
Else
	MsgBox (48, "ATTENTION !", "Le navigateur Mozilla Firefox n'a pas été trouvé sur votre PMF !" & @LF & @LF & _
							   "Vous êtes invités à faire une demande d'internvetion afin que le problème puisse être corrigé par votre support informatique !" & @LF & @LF & _
							   "En attendant, Internet Explorer est inscrit en tant que Navigateur par défaut pour le Rubik !")
	$vFirefox = "Navigateur non trouvé"
	$vfBits = " "
EndIf

If FileExists ("C:\Program Files (x86)\BraveSoftware\Brave-Browser\Application\brave.exe") Then
	$vBrave = "C:\Program Files (x86)\BraveSoftware\Brave-Browser\Application\brave.exe"
	$vcBits = "32 Bits"
Else
	$vBrave = "Navigateur non trouvé"
	$vcBits = " "
	If FileExists ("C:\Program Files (x86)\Mozilla Firefox\firefox.exe") Then
		$vFirefox = "C:\Program Files (x86)\Mozilla Firefox\firefox.exe"
		$vfBits = "32 Bits"
		IniWrite ($CONFIG_NAV, "NAVIGATEUR", "Chemin", $vFirefox)
		MsgBox (48, "ATTENTION !", "Le navigateur Brave n'a pas été trouvé sur votre PMF !" & @LF & @LF & _
								   "Vous êtes invités à faire une demande d'internvetion afin que le problème puisse être corrigé par votre support informatique !" & @LF & @LF & _
								   "En attendant, Mozilla Firefox est inscrit en tant que Navigateur par défaut pour le Rubik !")
	EndIf
EndIf

$Lect_NAV	= IniRead ($CONFIG_NAV, "NAVIGATEUR", "Chemin", "")
FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Navigateur par défaut du Rubik : " & $Lect_NAV)

If $Lect_NAV = $vFirefox Then $Value_NAV = "Mozilla Firefox - 32Bits"
If $Lect_NAV = $vBrave Then $Value_NAV = "Brave - 32Bits"
$Lect_Color	= IniRead ($CONFIG_NAV, "COULEUR", "Rubik", "")

$NOM		= "Adaptation du script par Prénom Nom."																					; Réalisation de l'adaptation du Script
$COURRIEL	= "Pour tout problème ou ajout de lien, contactez-moi par courriel à l'adresse : adresse_mail@mail.fr"	; Adresse mail
$VERSION	= FileGetVersion(@AutoItExe, $FV_FILEVERSION)																					; Numéro de version
	FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " La version du Rubik est : " & $VERSION)
;****************************************************************************************************************
;* Inscription de la version de Rubik dans la base de registre pour remontée dans le portail informatique		*
;****************************************************************************************************************
$REG	= "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Uninstall\Rubik\"													; Clé de registre à créer ou modifier
$Publisher_VALUE	= "Prénom Nom"																										; Clé de registre à créer ou modifier
$DisplayName_VALUE	= "Rubik"																												; Clé de registre à créer ou modifier
$DisplayIcon_VALUE	= @ScriptDir & "\Rubik.exe"																							; Clé de registre à créer ou modifier
$UninstallString_VALUE = "Pour désinstaller Rubik, supprimez simplement le répertoire"														; Clé de registre à créer ou modifier
	FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Création de la clé de registre : " & $REG)
	RegWrite($REG, "Publisher", "REG_SZ", $Publisher_VALUE)
	RegWrite($REG, "DisplayName", "REG_SZ", $DisplayName_VALUE)
	RegWrite($REG, "DisplayIcon", "REG_SZ", $DisplayIcon_VALUE)
	RegWrite($REG, "DisplayVersion", "REG_SZ", $VERSION)
	RegWrite($REG, "UninstallString", "REG_SZ", $UninstallString_VALUE)

;************************************
; A MODIFIER LORS D'UNE MISE À JOUR *
;************************************
$MAJ		= "Mise à jour du 06/01/2023 :" & @LF & "****************************" & @LF & _
													"Refonte complète du Rubik :" & @LF & _
													"- Ajout d'une fonction de consultation des exclusions" & @LF & _
													"- Ajout d'une fonction de sélection personnelle des rubriques à utiliser avec le Rubik (Menu Sélection)" & @LF & _
													"- Ajout de la possibilité de charger le menu ELSM d'un autre échelon" & @LF & _
													"- Correction d'un bug d'affichage de l'adresse IP si connexion ethernet (pas de problème en wifi)" & @LF & _
													"- Correction d'un bug d'actualisation de l'adresse IP" & @LF & _
													"- Création d'un menu de configuration du Rubik" & @LF & _
													"- Création de plusieurs fichiers .ini de configuration (Menu_COMMUN.ini, Menu_ELSM.ini, Menu_SELECTION.ini et Menu_PERSO.ini)" & @LF & _
													"- Mise en place d'une SECTION COMMUNE gérée par la COMMUN" & @LF & _
													"- Mise en place d'une SECTION ELSM gérée par l'ELSM" & @LF & _
													"- Mise en place d'une SECTION PERSONNELLE gérée par l'utilisateur" & @LF & _
													"- Mise à jour automatique des liens du Menu_SELECTION si celui-ci existe" & @LF & _
													"- Modification de la gestion de la couleur principale du Rubik et des sous-menus" & @LF & _
													"- Refonte du fonctionnement individuel, sans dépendance d'un fichier .ini" & @LF & _
													"- Contrôle de la présence des navigateurs officiels à l'ouverture du Rubik"

;************************************************************************************************************************************************************************
;************************************************************************************************************************************************************************
Global Const $MIM_APPLYTOSUBMENUS = 0x80000000, $MIM_BACKGROUND = 0x00000002														; Constants required for SetMenuColor
;************************************************************************************************************************************************************************
;************************************************************************************************************************************************************************
;****************************************************************************
Local $menu_general

Local $nbr_section_commun
Local $nbr_section_elsm
Local $nbr_section_ma_selection
Local $nbr_section_personnelle
Local $nbr_menu_bas

Local $nbr_cle_commun[1000][2010]					; Tableau de la valeur (ligne de commandes à éxecuter)
Local $nbr_cle_elsm[1000][2010]					; Tableau de la valeur (ligne de commandes à éxecuter)
Local $nbr_cle_ma_selection[1000][2010]			; Tableau de la valeur (ligne de commandes à éxecuter)
Local $nbr_cle_personnelle[1000][2010]			; Tableau de la valeur (ligne de commandes à éxecuter)
Local $nbr_cle_menu_bas[1000][2010]				; Tableau de la valeur (ligne de commandes à éxecuter)

Local $tray_handle_commun[1000][2010]				; Tableau des handles
Local $tray_handle_elsm[1000][2010]				; Tableau des handles
Local $tray_handle_ma_selection[1000][2010]		; Tableau des handles
Local $tray_handle_personnelle[1000][2010]		; Tableau des handles
Local $tray_handle_menu_bas[1000][2010]			; Tableau des handles

Local $nom_app_commun[1000][2010]
Local $nom_app_elsm[1000][2010]
Local $nom_app_ma_selection[1000][2010]
Local $nom_app_personnelle[1000][2010]
Local $nom_app_menu_bas[1000][2010]

SetMenuColor($menu_general, $Lect_Color)		; Changer la couleur complète de Rubik
TraySetToolTip ($SCRIPT & " v." & $VERSION)
;*******************************************************************************************************************
; MAJ du Menu SELECTION
;*******************************************************************************************************************
;~ If FileExists ($CONFIG_Local_SELECTION) Then
;~ 	FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Une configuration par SELECTION est actuellement en place sur ce PMF")
;~ 	$aArray_SECTION = IniReadSectionNames ($CONFIG_Local_SELECTION)
;~ 		For $i = 1 To $aArray_SECTION[0]
;~ 			$aArray_SELECTION = IniReadSection ($CONFIG_Local_SELECTION, $aArray_SECTION[$i])
;~ 				For $j = 1 To $aArray_SELECTION[0][0]
;~ 					If FileExists ($CONFIG_Local_SELECTION) Then
;~ 						$aArray_SECTION_COMMUN = IniReadSectionNames ($CONFIG_COMMUN)
;~ 							For $g = 1 To $aArray_SECTION_COMMUN[0]
;~ 								$aArray_COMMUN = IniReadSection ($CONFIG_COMMUN, $aArray_SECTION_COMMUN[$g])
;~ 									For $h = 1 To $aArray_COMMUN[0][0]
;~ 										If $aArray_COMMUN[$h][0] = $aArray_SELECTION[$j][0] And $aArray_COMMUN[$h][0] & "=" & $aArray_COMMUN[$h][1] <> $aArray_SELECTION[$j][0] & "=" & $aArray_SELECTION[$j][1] Then
;~ 												ConsoleWrite("Section : " & $aArray_SECTION[$i] & @LF & " > MAJ du lien = " & $aArray_COMMUN[$h][0] & "=" & $aArray_SELECTION[$j][1] & @LF)
;~ 												IniWrite ($CONFIG_Local_SELECTION, $aArray_SECTION[$i], $aArray_COMMUN[$h][0], $aArray_COMMUN[$h][1])
;~ 												FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " MAJ du lien : Section : " & $aArray_SECTION[$i] & @LF & " > MAJ du lien = " & $aArray_COMMUN[$h][0] & "=" & $aArray_SELECTION[$j][1])
;~ 										EndIf
;~ 									Next
;~ 							Next
;~ 					EndIf
;~ 				Next
;~ 		Next
;~ EndIf

;***********************************************************************************************************************************************************************************************************************
; Construction du Rubik et inscription dans le fichier LOG
;***********************************************************************************************************************************************************************************************************************
	FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " *****************************************************************************************************")
	FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & "  Construction du Rubik et de tous ces menus")
	FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " _____________________________________________________________________________________________________")
	Local $Configuration = 		TrayCreateMenu ($Fd & " Configuration du Rubik v." & $VERSION)
								SetMenuColor($Configuration, 0xE5F9FF)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la rubrique : Configuration du Rubik v." & $VERSION)
	Local $APROPOS =			TrayCreateItem ("À Propos du script " & $SCRIPT & " v." & $VERSION, $Configuration)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la sous-rubrique : À Propos")
								TrayCreateItem ("", $Configuration)
								TrayCreateItem ($Fb & " CONFIGURATION " & $Fb, $Configuration)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la sous-rubrique : " & $Fb & " CONFIGURATION " & $Fb)
								TrayCreateItem("", $Configuration)
	Local $Start_Badgeuse = 		TrayCreateItem("Badgeuse au démarrage", $Configuration)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la sous-rubrique : Badgeuse au démarrage")
									If Not FileExists ("C:\Users\" & @UserName & "\AppData\Roaming\Microsoft\Windows\Start Menu\Programs\Startup\Badgeuse.lnk") Then
										TrayItemSetState ($Start_Badgeuse, $TRAY_UNCHECKED)
										TrayItemSetText ($Start_Badgeuse, "Activer Badgeuse au démarrage")
									Else
										TrayItemSetState ($Start_Badgeuse, $TRAY_CHECKED)
										TrayItemSetText ($Start_Badgeuse, "Désactiver Badgeuse au démarrage")
									EndIf
	Local $RUBIK_Selection =	TrayCreateItem ("Charger le Menu ELSM d'un autre ELSM", $Configuration)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la sous-rubrique : Charger le Menu ELSM d'un autre ELSM")
	Local $RUBIK_Color =		TrayCreateItem ("Changer la couleur de votre Rubik", $Configuration)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la sous-rubrique : Changer la couleur de votre Rubik")
								TrayCreateItem ("", $Configuration)
	Local $Fichiers_INI = 		TrayCreateMenu ("Fichiers .INI de configuration", $Configuration)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " _____________________________________________________________________________________________________")
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la sous-rubrique : Fichiers .INI de configuration")
								TrayCreateItem ('NE FAITES PAS TROP DE BETISES DANS CE MENU', $Fichiers_INI)
								TrayCreateItem ("", $Fichiers_INI)
								SetMenuColor($Fichiers_INI, 0x3333FF)
	Local $Menu_SELECTION =		TrayCreateMenu ('Votre fichier "Menu_SELECTION.ini"', $Fichiers_INI)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la sous-rubrique : Votre fichier Menu_SELECTION.ini")
								If Not FileExists ($CONFIG_Local_SELECTION) Then
									Local $Reinitialiser = TrayCreateItem ('Créer votre propre MENU_SELECTION', $Menu_SELECTION)
									SetMenuColor($Menu_SELECTION, 0x97F5C7)
								Else
									Local $Reinitialiser = TrayCreateItem ('Réinitialiser et supprimer votre MENU_SELECTION', $Menu_SELECTION)
									SetMenuColor($Menu_SELECTION, 0x5F5FFA)
								EndIf
	Local $Menu_COMMUN =		TrayCreateItem ('Ouvrir le fichier "Menu_COMMUN.ini"', $Fichiers_INI)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la sous-rubrique : Ouvrir le fichier Menu_COMMUN.ini")
								If Not FileExists ($CONFIG_Local_COMMUN) Then
									TrayItemSetText ($Menu_COMMUN, "Le fichier Menu_COMMUN.ini n'existe pas")
									TrayItemSetState ($Menu_COMMUN, $TRAY_DISABLE)
								EndIf
	Local $Menu_ELSM =			TrayCreateItem ('Ouvrir le fichier "Menu_ELSM.ini"', $Fichiers_INI)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la sous-rubrique : Ouvrir le fichier Menu_ELSM.ini")
								If Not FileExists ($CONFIG_Local_ELSM) Then
									TrayItemSetText ($Menu_ELSM, "Le fichier Menu_ELSM.ini n'existe pas")
									TrayItemSetState ($Menu_ELSM, $TRAY_DISABLE)
								EndIf
	Local $Menu_PERSO =			TrayCreateItem ('Ouvrir le fichier "Menu_PERSO.ini"', $Fichiers_INI)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la sous-rubrique : Ouvrir le fichier Menu_PERSO.ini")
								If Not FileExists ($CONFIG_Local_PERSONNELLE) Then
									TrayItemSetText ($Menu_PERSO, "Le fichier Menu_PERSO.ini n'existe pas")
									TrayItemSetState ($Menu_PERSO, $TRAY_DISABLE)
								Else
								EndIf
	Local $ini_Rubik =			TrayCreateItem ('Ouvrir le fichier "Rubik.ini"', $Fichiers_INI)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la sous-rubrique : Ouvrir le fichier Rubik.ini")
								If Not FileExists ($CONFIG_NAV) Then
									TrayItemSetText ($ini_Rubik, "Le fichier Rubik.ini n'existe pas")
									TrayItemSetState ($ini_Rubik, $TRAY_DISABLE)
								EndIf
								TrayCreateItem ("", $Configuration)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " _____________________________________________________________________________________________________")
	Local $RUBIK = 				TrayCreateItem ("Changer le navigateur du Rubik : " & $Value_NAV, $Configuration)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la sous-rubrique : Changer le navigateur du Rubik")
								TrayCreateItem ("", $Configuration)
	Local $Restart =			TrayCreateItem ("Redémarrer votre Rubik", $Configuration)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la sous-rubrique : Redémarrer votre Rubik")
								If Not FileExists ($CONFIG_Local_PERSONNELLE) Then
									TrayItemSetText ($Restart, "Cette option n'est pas possible selon votre configuration")
									TrayItemSetState ($Restart, $TRAY_DISABLE)
								EndIf
	Local $Exit =				TrayCreateItem ("Quitter " & $SCRIPT, $Configuration)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de la sous-rubrique : Quitter")
								TrayCreateItem ("")
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " *****************************************************************************************************")
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & "  Création de la partie Informations sur l'utilisateur :")
	Local $User =				TrayCreateItem ("Nom de session : " & @UserName)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de l'information : Nom de session")
	Local $PMF =				TrayCreateItem ("Nom du PMF : " & @ComputerName)
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de l'information : @ComputerName")
	$AdresseIP = ""
	Local $IP =					TrayCreateItem ("Mon adresse IP : " & $AdresseIP)
								_IP()
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "  Création de l'information : @AdressIP")
								;*******************************************************************************************************************************
								; Appel de la fonction pour la création des menus en fonction des fichiers de configuration Menu_XXXX.ini présent dans CFG
								;*******************************************************************************************************************************
								If FileExists ($CONFIG_Local_SELECTION)	Then
									_TRAY_SELECTION()
								Else
									If FileExists ($CONFIG_Local_ELSM) Then	_TRAY_ELSM()
									If FileExists ($CONFIG_Local_COMMUN) Then	_TRAY_COMMUN()
								EndIf
;~ 								If FileExists ($CONFIG_Local_PERSONNELLE) Then _TRAY_PERSONNELLE()
								TrayCreateItem ("")
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " *****************************************************************************************************")
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & "  Création de la partie stricte régionale :")
								If FileExists ($CONFIG_Local_BAS) Then _TRAY_BAS()
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " _____________________________________________________________________________________________________")
								FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Le Rubik est maintenant construit, ouvert et en attente d'une action dans les différents menus")
								FileWriteLine ($LOG, " ")
								FileWriteLine ($LOG, " ")
								TraySetState(1)
;***********************************************************************************************************************************************************************************************************************
; Fin de la construction du Rubik
;***********************************************************************************************************************************************************************************************************************

;***********************************************************************************************************************************************************************************************************************
; Boucle principale qui attend la sélection d'un item
;***********************************************************************************************************************************************************************************************************************

While 1
$MSG = TrayGetMsg()
	Select
		Case $MSG = $APROPOS
			FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Ouverture du À Propos")
			MsgBox ($MB_OK, "Informations :", "Nom du script : " & $SCRIPT & @LF & @LF & "Version : " & $VERSION & @LF & @LF & $MAJ & @LF & @LF & $NOM & @LF & @LF & $COURRIEL)
 		Case $MSG = $Start_Badgeuse
			FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Ouverture de Badgeuse")
 			Badgeuse()
		Case $MSG = $Restart
			If Run (@ScriptDir & "\Restart.exe", @ScriptDir) Then FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Redémarrage du Rubik")
		Case $MSG = $Exit
			FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Le Rubik a été fermé")
			Exit
		Case $MSG = $User
			If ShellExecute ("C:\Program Files\PASSEPORT_Outils\SSOADM.exe") Then FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Ouverture de SSOADM")
		Case $MSG = $PMF
			If ShellExecute ("C:\") Then FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & "  Le nom de l'utilsiateur a été cliqué")
		Case $MSG = $IP
			FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Mise à jour de l'adresse IP présente dans le Rubik")
			_IP()
		Case $MSG = $RUBIK
			FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Modification du navigateur du Rubik")
			Local $hGUI			= GUICreate("Définir le navigateur par défaut du Rubik", 500, 185, -1, -1, $WS_POPUPWINDOW, $WS_EX_TOPMOST)
									GUISetBkColor(0xFFFFFF, $hGUI)
			Local $IMG_FIREFOX	= GUICtrlCreatePic(@ScriptDir & "\CFG\IMG\Firefox-icon.jpg", 40, 10, 40, 40)
			Local $Firefox		= GUICtrlCreateRadio("Définir Mozilla Firefox comme navigateur avec le Rubik", 110, 20, 400, 20)
									If Not FileExists ($vFirefox) Then GUICtrlSetstate ($Firefox, $GUI_DISABLE + $GUI_UNCHECKED)
			Local $IMG_IE		= GUICtrlCreatePic(@ScriptDir & "\CFG\IMG\Internet-Explorer-icon.jpg", 40, 70, 40, 40)
			Local $Internet		= GUICtrlCreateRadio("Internet Explorer n'est plus conforme", 110, 80, 400, 20)
									GUICtrlSetstate ($Internet, $GUI_DISABLE + $GUI_UNCHECKED)
			Local $IMG_BRAVE	= GUICtrlCreatePic(@ScriptDir & "\CFG\IMG\Brave.jpg", 40, 130, 40, 40)
			Local $Brave		= GUICtrlCreateRadio("Définir Brave comme navigateur avec le Rubik", 110, 140, 400, 20)
									If Not FileExists ($vBrave) Then GUICtrlSetstate ($Brave, $GUI_DISABLE + $GUI_UNCHECKED)
								  GUISetState(@SW_SHOW, $hGUI)
			; Boucle jusqu'à ce que l'utilisateur quitte.
			Local $idMsg
				Do
				$idMsg = GUIGetMsg()
					If _IsChecked ($Firefox) Then
						IniWrite ($CONFIG_NAV, "NAVIGATEUR", "Chemin", $vFirefox)
						$Lect_NAV	= IniRead ($CONFIG_NAV, "NAVIGATEUR", "Chemin", "")
						TrayItemSetText  ($RUBIK, "Navigateur du Rubik : Mozilla Firefox - " & $vfBits)
						GUIDelete($hGUI)
						$idMsg = $GUI_EVENT_CLOSE
					EndIf
					If _IsChecked ($Brave) Then
						IniWrite ($CONFIG_NAV, "NAVIGATEUR", "Chemin", $vBrave)
						$Lect_NAV	= IniRead ($CONFIG_NAV, "NAVIGATEUR", "Chemin", "")
						TrayItemSetText  ($RUBIK, "Navigateur du Rubik : Brave - " & $vcBits)
						GUIDelete($hGUI)
						$idMsg = $GUI_EVENT_CLOSE
					EndIf
				Until ($idMsg = $GUI_EVENT_CLOSE)
			; Supprime la GUI précédente et tous les contrôles.
		Case $MSG = $Reinitialiser
			If FileExists ($CONFIG_Local_SELECTION) Then
				FileDelete ($Install_Log)
				FileDelete ($CONFIG_Local_SELECTION)
				MsgBox (48, "ATTENTION", "Vous avez réinitialiser la configuration des menus du Rubik, ce dernier va être fermé." & @LF & @LF & "La réouverture de ce dernier est automatique.")
				Run (@ScriptDir & "\Restart.exe", @ScriptDir)
			Else
				Run (@ScriptDir & "\CFG\ConfigMenus.exe")
				Exit
			EndIf
		Case $MSG = $Menu_SELECTION
				If ShellExecute ($CONFIG_Local_SELECTION) Then FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Ouverture de : " & $CONFIG_Local_SELECTION)
		Case $MSG = $Menu_COMMUN
				If ShellExecute ($CONFIG_Local_COMMUN) Then FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Ouverture de : " & $CONFIG_Local_COMMUN)
		Case $MSG = $Menu_ELSM
				If ShellExecute ($CONFIG_Local_ELSM) Then FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Ouverture de : " & $CONFIG_Local_ELSM)
		Case $MSG = $Menu_PERSO
				If ShellExecute ($CONFIG_Local_PERSONNELLE) Then FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Ouverture de : " & $CONFIG_Local_PERSONNELLE)
		Case $MSG = $ini_Rubik
				If ShellExecute ($CONFIG_NAV) Then FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Ouverture de : " & $CONFIG_NAV)
		Case $MSG = $RUBIK_Color
			Run (@ScriptDir & "\CFG\CFG-Couleur.exe")
			Exit
		Case $MSG = $RUBIK_Selection
			Run (@ScriptDir & "\CFG\SELECT-Rubik.exe")
			Exit
	EndSelect
	For $q = 1 To $nbr_section_ma_selection                                             					; Boucle des sections
		For $r = 1 To $nbr_cle_ma_selection[$q][0]                                       					; Boucle des clés de la section en cours
			If $MSG = $tray_handle_ma_selection[$q][$r] Then                             					; Test si c'est cet item ( handle ) qui est sélectioné
				TrayItemSetState ($tray_handle_ma_selection[$q][$r], $TRAY_UNCHECKED)    					; Décochage de l'item (par defaut autoit coche les item sélectionnés)
				ConsoleWrite ("Lancement SECTION SELECTION de " & $nom_app_ma_selection[$q][$r] & @LF)
			EndIf
		Next
	Next
	For $g = 1 To $nbr_section_commun                                              					; Boucle des sections
		For $h = 1 To $nbr_cle_commun[$g][0]                                       					; Boucle des clés de la section en cours
			If $MSG = $tray_handle_commun[$g][$h] Then                             					; Test si c'est cet item ( handle ) qui est sélectioné
				TrayItemSetState ($tray_handle_commun[$g][$h], $TRAY_UNCHECKED)    					; Décochage de l'item (par defaut autoit coche les item sélectionnés)
				ConsoleWrite ("Lancement SECTION COMMUN de " & $nom_app_commun[$g][$h] & @LF)
				ConsoleWrite ("$nbr_section_commun = " & $nbr_section_commun & @LF)
				ConsoleWrite ("$nbr_cle_commun[$g][0] = " & $nbr_cle_commun[$g][0] & @LF)
				ConsoleWrite ("$tray_handle_commun[$g][$h] = " & $tray_handle_commun[$g][$h] & @LF)
			EndIf
		Next
	Next
	For $u = 1 To $nbr_section_elsm                                              					; Boucle des sections
		For $v = 1 To $nbr_cle_elsm[$u][0]                                       					; Boucle des clés de la section en cours
			If $MSG = $tray_handle_elsm[$u][$v] Then                             					; Test si c'est cet item ( handle ) qui est sélectioné
				TrayItemSetState ($tray_handle_elsm[$u][$v], $TRAY_UNCHECKED)    					; Décochage de l'item (par defaut autoit coche les item sélectionnés)
				ConsoleWrite ("Lancement SECTION ELSM de " & $nom_app_elsm[$u][$v] & @LF)
				ConsoleWrite ("$nbr_section_elsm = " & $nbr_section_elsm & @LF)
				ConsoleWrite ("$nbr_cle_elsm[$u][0]  = " & $nbr_cle_elsm[$u][0]  & @LF)
				ConsoleWrite ("$tray_handle_elsm[$u][$v] = " & $tray_handle_elsm[$u][$v] & @LF)
			EndIf
		Next
	Next
	For $k = 1 To $nbr_section_personnelle                    	                        			; Boucle des sections
		For $l = 1 To $nbr_cle_personnelle[$k][0]                                       			; Boucle des clés de la section en cours
			If $MSG = $tray_handle_personnelle[$k][0] Then                             			; Test si c'est cet item ( handle ) qui est sélectioné
				TrayItemSetState ($tray_handle_personnelle[$k][$l], $TRAY_UNCHECKED)    				; Décochage de l'item (par defaut autoit coche les item sélectionnés)
				ConsoleWrite ("Lancement SECTION PERSONNELLE de " & $nom_app_personnelle[$k][0] & @LF)
				ConsoleWrite ("$nbr_section_personnelle = " & $nbr_cle_personnelle & @LF)
				ConsoleWrite ("$nbr_cle_personnelle[$k][0] = " & $nbr_cle_personnelle[$k][0] & @LF)
				ConsoleWrite ("$tray_handle_personnelle[$k][$l] = " & $tray_handle_personnelle[$k][$l] & @LF)
			EndIf
		Next
	Next
	For $f = 1 To $nbr_menu_bas                                        						; Boucle des sections
		If $MSG = $tray_handle_menu_bas[$f][0] Then                             					; Test si c'est cet item ( handle ) qui est sélectioné
			TrayItemSetState ($tray_handle_menu_bas[$f][0], $TRAY_UNCHECKED)    						; Décochage de l'item (par defaut autoit coche les item sélectionnés)
				ConsoleWrite ("Lancement MENU BAS de " & $nom_app_menu_bas[$f][0] & @LF)
				ConsoleWrite ("$nbr_menu_bas = " & $nbr_menu_bas & @LF)
				ConsoleWrite ("$tray_handle_menu_bas[$f][0] = " & $tray_handle_menu_bas[$f][0] & @LF)
		EndIf
	Next
WEnd

Func _TRAY_PERSONNELLE()                                                                             								; Fonction pour la création du tray
	$var_personnelle = IniReadSectionNames(@ScriptDir & "\" & $CONFIG_Local_PERSONNELLE)                          					; Lecture des sections du fichier ini
	If @error Then
        MsgBox(4096, "", "Il manque le fichier " & @ScriptDir & "\" & $CONFIG_Local_PERSONNELLE)
    Else
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " *****************************************************************************************************")
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & "  Construction de la SECTION PERSONNELLE")
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " *****************************************************************************************************")
			TrayCreateItem("")
			$Perso = TrayCreateMenu($Fd & " SECTION PERSONNELLE " & $Fd)
			FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & $Fd & " SECTION PERSONNELLE " & $Fd)
			$nbr_section_personnelle = $var_personnelle[0]                                                 							; Stokage du nombre de section dans la variable
;~ 			ConsoleWrite ("section personnelle = " & $nbr_section_personnelle & @LF)
			For $k = 1 To $nbr_section_personnelle						                                    						; Boucle des sections
				$var_personnelle2 = IniReadSection(@ScriptDir & "\" & $CONFIG_Local_PERSONNELLE, $var_personnelle[$k])      		; Lecture des clés de la section en cours
				$tray_handle_personnelle[$k][0] = TrayCreateMenu($var_personnelle[$k], $Perso)                              		; Création des titres du menu avec le nom de la section et stokage du handle dans le tableau
				$nbr_cle_personnelle[$k][0] = $var_personnelle2[0][0]
						For $l = 1 To $nbr_cle_personnelle[$k][0]                                                      						; Boucle des clés de la section en cours
							$tray_handle_personnelle[$k][$l] = TrayCreateItem($var_personnelle2[$l][0], $tray_handle_personnelle[$k][0])                              		; Création des titres du menu avec le nom de la section et stokage du handle dans le tableau
;~ 							ConsoleWrite (@TAB & $var_personnelle2[$l][0] & @LF)
;~ 							SetMenuColor($tray_handle_commun[$g][0], 0xE5F9FF)
							SetMenuColor($tray_handle_personnelle[$k][0], 0xE5F9FF)
	 						$nbr_cle_personnelle[$k][$l] = $var_personnelle2[$l][1]                                            			; Stockage dans le tableau de la valeur (ligne de commande à exécuter)
							$nom_app_personnelle[$k][$l] = $var_personnelle2[$l][0]
							FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "[" & $var_personnelle[$k] & "]")
							FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & $var_personnelle2[$l][0])
							FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$nbr_section_personnelle = " & $nbr_section_personnelle)
							FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$tray_handle_personnelle[$k][0] = " & $tray_handle_personnelle[$k][0])
							FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$tray_handle_personnelle[$k][$l] = " & $tray_handle_personnelle[$k][$l])
							FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$nbr_cle_personnelle[$k][0] = " & $nbr_cle_personnelle[$k][0])
							FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$nom_app_personnelle[$k][$l] = " & $nom_app_personnelle[$k][$l])
							FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$nbr_cle_personnelle[$k][$l] = " & $nbr_cle_personnelle[$k][$l])
							FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "_______________________________________")
	;~ 						FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$nbr_section_personnelle2 = " & $nbr_section_personnelle2)
	;~ 						FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$nbr_ss_cle_personnelle = " &$nbr_ss_cle_personnelle)
						Next
			Next
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " _____________________________________________________________________________________________________")
	EndIf
EndFunc

Func _TRAY_COMMUN()                                                                             												; Fonction pour la création du tray
	$var_commun = IniReadSectionNames(@ScriptDir & "\" & $CONFIG_Local_COMMUN)                                							; Lecture des sections du fichier ini
	If @error Then
        MsgBox(4096, "", "Il manque le fichier " & @ScriptDir & "\" & $CONFIG_Local_COMMUN)
    Else
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " *****************************************************************************************************")
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & "  Construction de la SECTION COMMUNE")
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " *****************************************************************************************************")
			TrayCreateItem("")
			TrayCreateItem($Fb & " SECTION COMMUNE " & $Fb)
			TrayCreateItem("")
			$nbr_section_commun = $var_commun[0]                                                           			 						; Stokage du nombre de section dans la variable
;~ 			ConsoleWrite ("section commun = " & $nbr_section_commun & @LF)
			For $g = 1 To $nbr_section_commun						                                 			  							; Boucle des sections
			FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "[" & $var_commun[$g] & "]")
				$var_commun2 = IniReadSection(@ScriptDir & "\" & $CONFIG_Local_COMMUN, $var_commun[$g])                 						; Lecture des clés de la section en cours
				$tray_handle_commun[$g][0] = TrayCreateMenu($var_commun[$g])                               			 						; Création des titres du menu avec le nom de la section et stokage du handle dans le tableau
				$nbr_cle_commun[$g][0] = $var_commun2[0][0]                                                			 						; Stockage de nombre de clé pour la section en cours
;~ 				ConsoleWrite ("clé commun = " & $nbr_cle_commun[$g][0] & @LF)
					For $h = 1 To $nbr_cle_commun[$g][0]                                                   									; Boucle des clés de la section en cours
						$tray_handle_commun[$g][$h] = TrayCreateItem($var_commun2[$h][0], $tray_handle_commun[$g][0])							; Création de la liste d'items du menu (avec le nom de la clé) de la section en cours plus stockage du handle dans le tableau
						FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & $var_commun2[$h][0] & "=" & $var_commun2[$h][1])
						SetMenuColor($tray_handle_commun[$g][0], 0xE5F9FF)
						$nbr_cle_commun[$g][$h] = $var_commun2[$h][1]                                       								; Stockage dans le tableau de la valeur (ligne de commande à exécuter)
						$nom_app_commun[$g][$h] = $var_commun2[$h][0]
						FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$nbr_section_commun = " & $nbr_section_commun)
						FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$tray_handle_commun[$g][0] = " & $tray_handle_commun[$g][0])
						FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$tray_handle_commun[$g][$h] = " & $tray_handle_commun[$g][$h])
						FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$nbr_cle_commun[$g][0] = " & $nbr_cle_commun[$g][0])
					Next
			Next
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " _____________________________________________________________________________________________________")
	EndIf
EndFunc

Func _TRAY_SELECTION()                                                                             						; Fonction pour la création du tray
	If FileExists ($CONFIG_Local_SELECTION) Then
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " *****************************************************************************************************")
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Construction du Menu MA SELECTION")
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " *****************************************************************************************************")
		$var_ma_selection = IniReadSectionNames(@ScriptDir & "\" & $CONFIG_Local_SELECTION)													; Lecture des sections du fichier ini
			TrayCreateItem("")
			TrayCreateItem($Fb & " MA SELECTION " & $Fb)
			TrayCreateItem("")
			$nbr_section_ma_selection = $var_ma_selection[0]                                                 								; Stokage du nombre de section dans la variable
			For $q = 1 To $nbr_section_ma_selection						                                    								; Boucle des sections
			FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "[" & $var_ma_selection[$q] & "]")
				$var_ma_selection2 = IniReadSection(@ScriptDir & "\" & $CONFIG_Local_SELECTION, $var_ma_selection[$q])  					; Lecture des clés de la section en cours
				$tray_handle_ma_selection[$q][0] = TrayCreateMenu($var_ma_selection[$q]) 				                					; Création des titres du menu avec le nom de la section et stokage du handle dans le tableau
				$nbr_cle_ma_selection[$q][0] = $var_ma_selection2[0][0]                                                 					; Stockage de nombre de clé pour la section en cours
					For $r = 1 To $var_ma_selection2[0][0]                                                      							; Boucle des clés de la section en cours
						$tray_handle_ma_selection[$q][$r] = TrayCreateItem($var_ma_selection2[$r][0], $tray_handle_ma_selection[$q][0]) 	; Création de la liste d'items du menu (avec le nom de la clé) de la section en cours plus stockage du handle dans le tableau
						FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & $var_ma_selection2[$r][0] & "=" & $var_ma_selection2[$r][1])
						SetMenuColor($tray_handle_ma_selection[$q][0], 0xE5F9FF)
						$nbr_cle_ma_selection[$q][$r] = $var_ma_selection2[$r][1]                                            				; Stockage dans le tableau de la valeur (ligne de commande à exécuter)
						$nom_app_ma_selection[$q][$r] = $var_ma_selection2[$r][0]
					Next
			Next
	EndIf
EndFunc

Func _TRAY_BAS()                                                                             												; Fonction pour la création du tray
	$var_menu_bas = IniReadSection(@ScriptDir & "\" & $CONFIG_Local_BAS, "MENU_BAS")                          							; Lecture des sections du fichier ini
	If @error Then
        MsgBox(4096, "", "Il manque le fichier " & @ScriptDir & "\" & $CONFIG_Local_BAS)
    Else
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " *****************************************************************************************************")
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " Construction du Menu BAS")
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " *****************************************************************************************************")
		$nbr_menu_bas = $var_menu_bas[0][0]
			For $f = 1 To $var_menu_bas[0][0]						                                    									; Boucle des sections
				$nbr_cle_menu_bas[$f][0] = $var_menu_bas[0][0]
				$tray_handle_menu_bas[$f][0] = TrayCreateItem($var_menu_bas[$f][0]) 														; Création de la liste d'items du menu (avec le nom de la clé) de la section en cours plus stockage du handle dans le tableau
				FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & $var_menu_bas[$f][0] & "=" & $var_menu_bas[$f][1])
				$nbr_cle_menu_bas[$f][1] = $var_menu_bas[$f][1]																				; Stockage dans le tableau de la valeur (ligne de commande à exécuter)
				$nom_app_menu_bas[$f][0] = $var_menu_bas[$f][0]
			Next
	EndIf
EndFunc

Func _TRAY_ELSM()                                       	                                      											; Fonction pour la création du tray
	$var_elsm = IniReadSectionNames(@ScriptDir & "\" & $CONFIG_Local_ELSM)                          								; Lecture des sections du fichier ini
	If @error Then
        MsgBox(4096, "", "Il manque le fichier " & @ScriptDir & "\" & $CONFIG_Local_ELSM)
    Else
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " *****************************************************************************************************")
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & "  Construction de la SECTION ELSM")
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " *****************************************************************************************************")
			TrayCreateItem("")
			TrayCreateItem($Fb & " SECTION ELSM " & $Fb)
			TrayCreateItem("")
			$nbr_section_elsm = $var_elsm[0]                                                 											; Stokage du nombre de section dans la variable
			For $u = 1 To $nbr_section_elsm			                                    												; Boucle des sections
			FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & "[" & $var_elsm[$u] & "]")
				$var_elsm2 = IniReadSection(@ScriptDir & "\" & $CONFIG_Local_ELSM, $var_elsm[$u])      									; Lecture des clés de la section en cours
				$tray_handle_elsm[$u][0] = TrayCreateMenu($var_elsm[$u])                                  								; Création des titres du menu avec le nom de la section et stokage du handle dans le tableau
				$nbr_cle_elsm[$u][0] = $var_elsm2[0][0]                                                  								; Stockage de nombre de clé pour la section en cours
					For $v = 1 To $var_elsm2[0][0]                                                      								; Boucle des clés de la section en cours
						$tray_handle_elsm[$u][$v] = TrayCreateItem($var_elsm2[$v][0], $tray_handle_elsm[$u][0])  						; Création de la liste d'items du menu (avec le nom de la clé) de la section en cours plus stockage du handle dans le tableau
						FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & $var_elsm2[$v][0] & "=" & $var_elsm2[$v][1])
						SetMenuColor($tray_handle_elsm[$u][0], 0xE5F9FF)
						$nbr_cle_elsm[$u][$v] = $var_elsm2[$v][1]                                            							; Stockage dans le tableau de la valeur (ligne de commande à exécuter)
						$nom_app_elsm[$u][$v] = $var_elsm2[$v][0]
						FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$nbr_section_elsm = " & $nbr_section_elsm)
						FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$tray_handle_elsm[$u][0] = " & $tray_handle_elsm[$u][0])
						FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$tray_handle_elsm[$g][$h] = " & $tray_handle_elsm[$u][$v])
						FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & @TAB & @TAB & @TAB & "$nbr_cle_elsm[$u][0] = " & $nbr_cle_elsm[$u][0])
					Next
			Next
		FileWriteLine ($LOG, @TAB & @TAB & _NowTime(5) & " " & $Fl & " _____________________________________________________________________________________________________")
	EndIf
EndFunc

Func _IP()
	Global $AdresseIP =	@IPAddress1
	$String_IP = StringSplit ($AdresseIP, ".")
		If $String_IP[1] <> "55" Then
			Global $AdresseIP = @IPAddress2
		EndIf
	TrayItemSetText ($IP, "Mon adresse IP : " & $AdresseIP)
	If $Maj_IP = 1 Then
		MsgBox (64, "Mise à jour de l'adreses IP", "Votre adresse IP a été mise à jour dans le menu du Rubik." & @LF & @LF & "Votre nouvelle adresse détectée est : " & $AdresseIP)
	EndIf
	$Maj_IP = 1
EndFunc

Func Badgeuse()
	If BitAND(TrayItemGetState($Start_Badgeuse), $TRAY_CHECKED) = $TRAY_CHECKED Then
		FileDelete ("C:\Users\" & @UserName & "\AppData\Roaming\Microsoft\Windows\Start Menu\Programs\Startup\Badgeuse.lnk")
    	MsgBox (64,"Badgeuse Désactivé", "Badgeuse est maintenant désactivé à l'ouverture de session")
		TrayItemSetState ($Start_Badgeuse, $TRAY_UNCHECKED)
		TrayItemSetText ($Start_Badgeuse, "Activer Badgeuse au démarrage")
	Else
		If BitAND(TrayItemGetState($Start_Badgeuse), $TRAY_UNCHECKED) = $TRAY_UNCHECKED Then
		Local $Badgeuse = "http://Badgeuse/login"
		Local $DEMARRAGE = "C:\Users\" & @UserName & "\AppData\Roaming\Microsoft\Windows\Start Menu\Programs\Startup\"
		Local $iconFile = "\\SERVEUR\Informatique\Outils\ICONES\Badgeuse.ico"
			FileCreateShortcut($Lect_NAV, $DEMARRAGE & "Badgeuse.lnk", "", $Badgeuse, "", $iconFile, "", 0)
			MsgBox (64,"Badgeuse Activé", "Badgeuse est maintenant activé à l'ouverture de session")
			TrayItemSetState ($Start_Badgeuse, $TRAY_CHECKED)
			TrayItemSetText ($Start_Badgeuse, "Désactiver Badgeuse au démarrage")
		EndIf
	EndIf
EndFunc

Func SetMenuColor($iMenuID, $iColor)
    Local $hMenu = TrayItemGetHandle($iMenuID)  																		; Obtient le handle de menu interne
    Local $hBrush = DllCall("gdi32.dll", "hwnd", "CreateSolidBrush", "int", $iColor)
    $hBrush = $hBrush[0]
    Local $tMenuInfo = DllStructCreate("dword;dword;dword;uint;ptr;dword;ptr")
    DllStructSetData($tMenuInfo, 1, DllStructGetSize($tMenuInfo))
    DllStructSetData($tMenuInfo, 2, BitOR($MIM_APPLYTOSUBMENUS, $MIM_BACKGROUND))
    DllStructSetData($tMenuInfo, 5, $hBrush)
    DllCall("user32.dll", "int", "SetMenuInfo", "hwnd", $hMenu, "struct*", $tMenuInfo)
EndFunc

;~ 	****************************************************************************************************************************************************************
;~ 	* CONTRÔLE SI LA CASE EST COCHEE
;~ 	****************************************************************************************************************************************************************
Func _IsChecked($idControlID)
	Return BitAND(GUICtrlRead($idControlID), $GUI_CHECKED) = $GUI_CHECKED
EndFunc   ;==>_IsChecked
